(* Entrées/Sorties. *)

let debug =
  false

let read_file filename =
  let channel = open_in filename in
  MyStream.unfold (fun () ->
    try
      let c = input_char channel in
      if debug then
        Printf.fprintf stderr "LazyIO: read '%s'\n" (Char.escaped c);
      Some (Char.code c, ())
    with End_of_file ->
      if debug then
        Printf.fprintf stderr "LazyIO: done reading\n";
      close_in channel;
      None
  ) ()

let write_channel channel is =
  MyStream.iter (fun i ->
    let c = Char.chr i in
    if debug then
      Printf.fprintf stderr "LazyIO: wrote '%s'\n" (Char.escaped c);
    output_char channel c
  ) is

let write_file filename is =
  let channel = open_out filename in
  write_channel channel is;
  close_out channel

let compare file1 file2 =
  let s1 = read_file file1 in
  let s2 = read_file file2 in
  MyStream.equal(=)  s1 s2
